require "crowsad/version"

module Crowsad
  class Error < StandardError; end
  
  class Learn_First_Objects
    def self.teach_word
      require "duck_duck_go"
      
      old_first_object = File.read("dictionary/first_object.txt")
      
      new_word = File.read("data/input/first_object.txt").strip
  
      ddg = DuckDuckGo.new
      zci = ddg.zeroclickinfo(new_word)

      open("data/output/glossary/#{new_word}.txt", 'w') { |f|
        f.puts zci.heading
        f.puts zci.abstract_text
        f.puts zci.related_topics['_'][0].text
      }
      
      open('dictionary/first_object.txt', 'w') { |f|
        f.puts zci.heading
        
        f.puts old_first_object
      }
    end
  end
  
  class Learn_Present_Actions
    def self.teach_word
      require "duck_duck_go"
      
      old_present_action = File.read("dictionary/present_action.txt")
      
      new_word = File.read("data/input/present_action.txt").strip

      ddg = DuckDuckGo.new
      zci = ddg.zeroclickinfo(new_word)

      open("data/output/glossary/#{new_word}.txt", 'w') { |f|
        f.puts zci.heading
        f.puts zci.abstract_text
        f.puts zci.related_topics['_'][0].text
      }
      
      open('dictionary/present_action.txt', 'w') { |f|
        f.puts zci.heading
        
        f.puts old_present_action
      }
    end
  end
  
  class Learn_Second_Objects
    def self.teach_word
      require "duck_duck_go"
      
      old_second_object = File.read("dictionary/second_object.txt")
      
      new_word = File.read("data/input/second_object.txt").strip

      ddg = DuckDuckGo.new
      zci = ddg.zeroclickinfo(new_word)

      open("data/output/glossary/#{new_word}.txt", 'w') { |f|
        f.puts zci.heading
        f.puts zci.abstract_text
        f.puts zci.related_topics['_'][0].text
      }
      
      open('dictionary/second_object.txt', 'w') { |f|
        f.puts zci.heading
        
        f.puts old_second_object
      }
    end
  end
  
  class Learn_Next_Actions
    def self.teach_word
      require "duck_duck_go"
      
      old_next_action = File.read("dictionary/next_action.txt")

      new_word = File.read("data/input/next_action.txt").strip

      ddg = DuckDuckGo.new
      zci = ddg.zeroclickinfo(new_word)

      open("data/output/glossary/#{new_word}.txt", 'w') { |f|
        f.puts zci.heading
        f.puts zci.abstract_text
        f.puts zci.related_topics['_'][0].text
      }
      
      open('dictionary/next_action.txt', 'w') { |f|
        f.puts zci.heading
        
        f.puts old_next_action
      }
    end
  end
  
  class Learn_Third_Object
    def self.teach_word
      require "duck_duck_go"
      
      old_third_object = File.read("dictionary/third_object.txt")

      new_word = File.read("data/input/third_object.txt").strip

      ddg = DuckDuckGo.new
      zci = ddg.zeroclickinfo(new_word)

      open("data/output/glossary/#{new_word}.txt", 'w') { |f|
        f.puts zci.heading
        f.puts zci.abstract_text
        f.puts zci.related_topics['_'][0].text
      }
      
      open('dictionary/next_action.txt', 'w') { |f|
        f.puts zci.heading
        
        f.puts old_third_object
      }
    end
  end
  
  # Generating the dangling modifier datapoint from input vectors.
  class Generate_Dangling_Modifiers
  
    def self.formulate_phrase
      bot_name = File.read("bot_identity/bot_name.txt").strip
    
      old_data = File.read("data/output/modifier_list.txt")
      
      # Grammar A
      present_action      = File.readlines("dictionary/present_action.txt").sample.strip
      present_preposition = File.readlines("dictionary/present_preposition.txt").sample.strip
      first_object        = File.readlines("dictionary/first_object.txt").sample.strip
      
      # Grammar B
      second_object       = File.readlines("dictionary/second_object.txt").sample.strip
      next_preposition    = File.readlines("dictionary/next_preposition.txt").sample.strip
      next_action         = File.readlines("dictionary/next_action.txt").sample.strip
      
      # Final object
      third_object        = File.readlines("dictionary/third_object.txt").sample.strip
      
      # Inquire
      why_did = " Why did the"
      why_was = " why was the"
      
      grammar_a = "#{present_action}ing #{present_preposition} #{first_object}, "
      grammar_b = "#{second_object} #{next_action}s #{next_preposition} #{third_object}."
      
      inquire   = "#{why_did} #{second_object} #{next_action} #{next_preposition} #{third_object}?"
      for_that  = "For that matter,#{why_was} #{first_object} #{present_action} anything?"
      
      open("data/output/modifier_list.txt", "w") { |f|
        f.puts old_data
        
        f.puts "#{bot_name}: #{grammar_a}#{grammar_b} #{inquire} #{for_that}"
      }
    end
  
  end
end
